use Northwind
go
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GetManagerReports]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[GetManagerReports]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE  FUNCTION dbo.GetManagerReports ( @iEmployeeID int )
RETURNS @ManagerReports TABLE
   (
   	EmployeeID		int,
   	EmployeeFirstName nvarchar(10),
   	EmployeeLastName nvarchar(20),
	Title			nvarchar(30),
	TitleOfCourtesy	nvarchar(25),
	Extension		nvarchar(4),
   	ManagerID		int
   )
AS
BEGIN
	DECLARE @iRowsAdded		int 			-- Anzahl eingefgter Zeilen pro Durchgang
	DECLARE @Vorverarbeitung int
	DECLARE @Verarbeitung int
	DECLARE @NachVerarbeitung int

	SET	@VorVerarbeitung 		= 0
	SET	@Verarbeitung 		= 1
	SET	@NachVerarbeitung 	= 2

	DECLARE	@tblReports TABLE (
			-- Hlt die hinzugefgten Angestellten pro Durchgang der Tabelle
				EmployeeID				int,
	   			EmployeeFirstName    nvarchar(10),
		   		EmployeeLastName 	nvarchar(20),
				Title						nvarchar(30),
				TitleOfCourtesy			nvarchar(25),
				Extension				nvarchar(4),
	   			ManagerID				int,
				ProcessedState			tinyint 	DEFAULT 0
		)


	--Einfgen der Angestellten, die direkt zum Manager berichten
	INSERT INTO @tblReports
		SELECT EmployeeID, FirstName, LastName, Title, TitleOfCourtesy,
					Extension, ReportsTo, @VorVerarbeitung
		FROM Employees
		WHERE ReportsTo = @iEmployeeID

	--Diese Anzahl merken
	SET @iRowsAdded = @@ROWCOUNT

	-- Durch alle Angestellen laufen um alle indirekt berichtenden Angestellen zu finden
	WHILE @iRowsAdded > 0
	BEGIN
			--Status auf Verbeitung setzen
		UPDATE @tblReports SET ProcessedState = @Verarbeitung
		WHERE ProcessedState = @VorVerarbeitung

		--Alle Angestellten einfgen, die den Status Verarbeitung haben
		INSERT INTO @tblReports
			SELECT e.EmployeeID, e.FirstName, e.LastName, e.Title,
				e.TitleOfCourtesy, e.Extension, e.ReportsTo, @VorVerarbeitung
			FROM Employees e
				INNER JOIN @tblReports r ON e.ReportsTo = r.EmployeeID
				WHERE r.ProcessedState = @Verarbeitung AND e.ReportsTo <> @iEmployeeID

		--Anzahl speichern
		SET @iRowsAdded = @@ROWCOUNT

		--Status auf NachVerabeitung setzen
		UPDATE @tblReports SET ProcessedState = @NachVerarbeitung
		WHERE ProcessedState = @Verarbeitung
	END

	--Ausgabetabelle aufbauen
	INSERT INTO @ManagerReports
		SELECT EmployeeID, EmployeeFirstName, EmployeeLastName, Title,
			TitleOfCourtesy, Extension, ManagerID
		FROM @tblReports
   	RETURN
END



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

